/** 
 * 
 * Copyright 2004 Hiram Chirino
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.activemq;

import javax.jms.Connection;
import javax.jms.DeliveryMode;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;

import junit.framework.TestCase;

import org.activemq.message.ActiveMQDestination;

/**
 * @version $Revision: 1.1.1.1 $
 */
public class BrokerAdminCommandsTest extends TestCase {

	private Connection connection;

    protected void setUp() throws Exception {
		 ActiveMQConnectionFactory factory = new ActiveMQConnectionFactory("vm://localhost");
		 connection = factory.createConnection();
		 connection.start();
    }

    /**
     * @see junit.framework.TestCase#tearDown()
     */
    protected void tearDown() throws Exception {
		 connection.close();
    }

    
    /**
     * @throws JMSException
     */
    public void testDestroyDestination() throws JMSException {
        
         Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);

		 Queue queue = session.createQueue("testQueue");

		 // Send the message.
		 MessageProducer producer = session.createProducer(queue);		 
		 producer.setDeliveryMode(DeliveryMode.NON_PERSISTENT);
		 producer.send(session.createTextMessage("First"));
		 producer.setDeliveryMode(DeliveryMode.PERSISTENT);
		 producer.send(session.createTextMessage("Second"));
		 session.close();
		 
		 // This should remove all the messages that were sent to the destination.
		 ((ActiveMQConnection)connection).destroyDestination((ActiveMQDestination)queue);
		 
		 session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
		 
		 producer = session.createProducer(queue);		 
		 producer.setDeliveryMode(DeliveryMode.NON_PERSISTENT);
		 producer.send(session.createTextMessage("Last"));
		 
		 // Test the assertions.
		 MessageConsumer startedConsumer = session.createConsumer(queue);
		 Message m = startedConsumer.receive(1000);
		 assertNotNull(m);
		 
		 assertEquals( "Last", ((TextMessage)m).getText() );
    }
  
}